<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>LValue - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="FValue.html">FValue</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="FValue.html#set">set</a></li></ul></li><li><a href="LValue.html">LValue</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="LValue.html#getTurtoise">getTurtoise</a></li><li data-type='method' style='display: none;'><a href="LValue.html#setTurtoise">setTurtoise</a></li><li data-type='method' style='display: none;'><a href="LValue.html#deduce">deduce</a></li><li data-type='method' style='display: none;'><a href="LValue.html#.readTriples">readTriples</a></li></ul></li><li><a href="Value.html">Value</a><ul class='members'><li data-type='member' style='display: none;'><a href="Value.html#.EMPTY">EMPTY</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Value.html#asString">asString</a></li><li data-type='method' style='display: none;'><a href="Value.html#isEmpty">isEmpty</a></li><li data-type='method' style='display: none;'><a href="Value.html#isRecord">isRecord</a></li><li data-type='method' style='display: none;'><a href="Value.html#isArray">isArray</a></li><li data-type='method' style='display: none;'><a href="Value.html#isMember">isMember</a></li><li data-type='method' style='display: none;'><a href="Value.html#length">length</a></li><li data-type='method' style='display: none;'><a href="Value.html#getNames">getNames</a></li><li data-type='method' style='display: none;'><a href="Value.html#size">size</a></li><li data-type='method' style='display: none;'><a href="Value.html#get">get</a></li><li data-type='method' style='display: none;'><a href="Value.html#at">at</a></li><li data-type='method' style='display: none;'><a href="Value.html#aget">aget</a></li><li data-type='method' style='display: none;'><a href="Value.html#set">set</a></li><li data-type='method' style='display: none;'><a href="Value.html#add">add</a></li><li data-type='method' style='display: none;'><a href="Value.html#copy">copy</a></li><li data-type='method' style='display: none;'><a href="Value.html#erase">erase</a></li><li data-type='method' style='display: none;'><a href="Value.html#rename">rename</a></li><li data-type='method' style='display: none;'><a href="Value.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="Value.html#sort">sort</a></li><li data-type='method' style='display: none;'><a href="Value.html#sortNames">sortNames</a></li><li data-type='method' style='display: none;'><a href="Value.html#equals">equals</a></li></ul></li><li><a href="WJSONReader.html">WJSONReader</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="WJSONReader.html#.read">read</a></li></ul></li><li><a href="WJSONWriter.html">WJSONWriter</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="WJSONWriter.html#.write">write</a></li></ul></li><li><a href="wJSON.html">wJSON</a><ul class='methods'><li data-type='method' style='display: none;'><a href="wJSON.html#.parse">parse</a></li><li data-type='method' style='display: none;'><a href="wJSON.html#.stringify">stringify</a></li><li data-type='method' style='display: none;'><a href="wJSON.html#.wjson2json">wjson2json</a></li><li data-type='method' style='display: none;'><a href="wJSON.html#.wjson2wjson">wjson2wjson</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#quote">quote</a></li><li><a href="global.html#string2json">string2json</a></li><li><a href="global.html#run_protege">run_protege</a></li><li><a href="global.html#ttl2n3">ttl2n3</a></li><li><a href="global.html#wjson2html">wjson2html</a></li><li><a href="global.html#wjson2json">wjson2json</a></li><li><a href="global.html#wjson2wjson">wjson2wjson</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">LValue</h1>
    

    




<section>

<header>
    
        <h2>
        
            LValue
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="LValue"><span class="type-signature"></span>new LValue<span class="signature">(value<span class="signature-attributes">opt</span>, parse<span class="signature-attributes">opt</span>, sort_names<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements a minimal C/C++ ontology view of a <a href="https://www.json.org">JSON</a> data structure.</p>
<h4>Extends: <a href='./Value.html'>Value</a>, with all public methods available.</h4>
<ul>
<li>Such a LValue has the capability to interface with a ontology reasoner and other tools.</li>
<li>Value functions, beyond <a href="./Value.html">Value</a> functions
<ul>
<li>Input/Output:
<ul>
<li><a href="#setTurtoise"><code>setTurtoise(String value)</code></a> allows to append a data structure serialized as a <a href="./turtoise.pdf">Turtoise</a> set of triplets, using <a href="https://en.wikipedia.org/wiki/N-Triples">N-Triples</a> syntax.</li>
</ul>
</li>
<li><a href="#getTurtoise"><code>getTurtoise()</code></a> allows to output the data structure as a serialized <a href="./turtoise.pdf">Turtoise</a> set of triplets, using <a href="https://en.wikipedia.org/wiki/N-Triples">N-Triples</a> syntax.</li>
<li>Interface with the external reasoner:
<ul>
<li><a href="#deduce"><code>deduce()</code></a> runs an external reasoner to obtain deduced features.</li>
</ul>
</li>
</ul>
</li>
</ul>
<center><iframe style='width: 100%; height: calc(55vw);' src='./turtoise.pdf'></iframe></center><a href='./turtoise.pdf' target='_blank'>&nbsp;&nbsp;(open in new tab)</a><br/></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>
|

<span class="param-type">bool</span>
|

<span class="param-type">int</span>
|

<span class="param-type">uint</span>
|

<span class="param-type">double</span>
|

<span class="param-type">float</span>
|

<span class="param-type">JSON</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The initial value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>parse</code></td>
            

            <td class="type">
            
                
<span class="param-type">bool</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>false</code>
                
                </td>
            

            <td class="description last"><p>For a string value, if true parses the string using the <a href="./turtoise.pdf">Turtoise</a> semantic.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>sort_names</code></td>
            

            <td class="type">
            
                
<span class="param-type">bool</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>false</code>
                
                </td>
            

            <td class="description last"><p>For a parsed string value, if true sorts the names in alphabetic order, as performed by Value::sortNames().</p></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="getTurtoise"><span class="type-signature"></span>getTurtoise<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Outputs the data structure as a serialized <a href="./turtoise.pdf">Turtoise</a> set of triplets.</p>
<ul>
<li>The standard OWL prefixes are predefined:</li>
</ul>
<pre class="prettyprint source"><code>&#64;prefix owl: &lt;http://www.w3.org/2002/07/owl#> .
&#64;prefix rdfs: &lt;http://www.w3.org/2000/01/rdf-schema#> .
&#64;prefix rdf: &lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#> .
&#64;prefix xsd: &lt;http://www.w3.org/2001/XMLSchema#> .
&#64;prefix xml: &lt;http://www.w3.org/XML/1998/namespace> .
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The data structure content using <a href="https://en.wikipedia.org/wiki/N-Triples">N-Triples</a> syntax.</p>
</div>



    



        
            

    

    <h4 class="name" id="setTurtoise"><span class="type-signature"></span>setTurtoise<span class="signature">(string<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {<a href="Value.html">Value</a>}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Appends a data structure serialized as a <a href="./turtoise.pdf">Turtoise</a> set of triplets.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>string</code></td>
            

            <td class="type">
            
                
<span class="param-type">String</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            

            <td class="description last"><p>The input triples using the <a href="https://en.wikipedia.org/wiki/N-Triples">N-Triples</a> syntax.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>This value, allowing to chain set methods.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="Value.html">Value</a></span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="deduce"><span class="type-signature"></span>deduce<span class="signature">(value<span class="signature-attributes">opt</span>, wjson<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Runs an external reasoner to obtain deduced features.</p>
<ul>
<li>It is not available in the cygwin environment.</li>
<li>The present implementation interfaces with Protege using the <a href="./global.html#run_protege.html"><code>run_protege.sh</code></a> with
<ul>
<li><code>/tmp/run_protege.input.n3</code> as input,</li>
<li><code>/tmp/run_protege.input.n3.inferred.owl.n3</code> as output,</li>
<li><code>/tmp/run_protege.log</code> with the complete process log.</li>
</ul>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Value.html">Value</a></span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>A <code>Value*</code> pointer output value, by default append deduced features to this value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>wjson</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>"./src"</code>
                
                </td>
            

            <td class="description last"><p>The wjson current source files directory to access to the required scripts.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id=".readTriples"><span class="type-signature type-signature-static">(static) </span>readTriples<span class="signature">(string)</span><span class="type-signature"> &rarr; {<a href="Value.html">Value</a>}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Reads a string and return the best parsed structure.</p>
<ul>
<li>Implements a <a href="https://en.wikipedia.org/wiki/N-Triples">N-Triples</a> weak parser.
<ul>
<li>The triple IRI of the form <code>&lt;IRI&gt;</code> are unquoted (suppression of the <code>&lt;</code> and <code>&gt;</code>) and interal <code>&gt;</code> is unescaped.</li>
<li>The triple string of the form <code>&quot;string&quot;</code> are unquoted (suppression of the <code>&quot;</code>) and internal <code>&quot;</code> is unescaped.</li>
<li>The IRI of the form <code>local:</code> are unescaped (suppression of the <code>local:</code> prefix).</li>
</ul>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>string</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The input string to parse.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A <code>[[subject predicate object] …]</code> array with the triplets.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="Value.html">Value</a></span>



    </dd>
</dl>

    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-03-03 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>